# $Id: menu.tcl,v 1.1 1997/11/05 21:38:11 wtcorrea Exp wtcorrea $

source file.tcl
source color.tcl

set view VIEW_PHONG
set usegl USEGL_ON
set culling CULLING_OFF
set headlight HEADLIGHT_OFF
set projection PROJ_PERSPECTIVE

frame .menubar -relief raised -bd 2
menubutton .menubar.file -text File -underline 0 \
    -menu .menubar.file.menu
menubutton .menubar.view -text View -underline 0 \
    -menu .menubar.view.menu
menubutton .menubar.options -text Options -underline 0 \
    -menu .menubar.options.menu
menubutton .menubar.help -text Help -underline 0 \
    -menu .menubar.help.menu

menu .menubar.file.menu -tearoff 0
.menubar.file.menu add command -label "Open iv..." -underline 0 \
    -accelerator "\tCtrl+O" -command file_open
.menubar.file.menu add command -label "Save ppm..." -underline 0 \
    -accelerator "\tCtrl+S" -command file_save
.menubar.file.menu add separator
.menubar.file.menu add command -label Quit -underline 0 \
    -accelerator "\tCtrl+Q" -command file_quit

menu .menubar.view.menu -tearoff 0
.menubar.view.menu add radio -label "Points" -underline 1 \
    -variable view -value VIEW_POINTS
.menubar.view.menu add radio -label "Wireframe" -underline 0 \
    -variable view -value VIEW_WIREFRAME
.menubar.view.menu add radio -label "Flat" -underline 0 \
    -variable view -value VIEW_FLAT
.menubar.view.menu add radio -label "Gouraud" -underline 0 \
    -variable view -value VIEW_GOURAUD
.menubar.view.menu add radio -label "Phong" -underline 0 \
    -variable view -value VIEW_PHONG

menu .menubar.options.menu -tearoff 0
.menubar.options.menu add command -label "Background color..." \
    -underline 0 -command options_bgcolor
.menubar.options.menu add check -label "Open GL mode" \
    -underline 0 -accelerator "\tCtrl+T" -variable usegl \
    -onvalue USEGL_ON -offvalue USEGL_OFF
.menubar.options.menu add check -label "Backface culling" \
    -underline 9 -variable culling \
    -onvalue CULLING_ON -offvalue CULLING_OFF
.menubar.options.menu add check -label "Headlight" \
    -underline 0 -variable headlight \
    -onvalue HEADLIGHT_ON -offvalue HEADLIGHT_OFF
.menubar.options.menu add cascade -label "Projection" \
    -underline 0  -menu .menubar.options.menu.proj

set m [menu .menubar.options.menu.proj -tearoff 0]
$m add radio -label "Perspective" -underline 0 \
    -variable projection -value PROJ_PERSPECTIVE
$m add radio -label "Orthogonal" -underline 0 \
    -variable projection -value PROJ_ORTHOGONAL

menu .menubar.help.menu -tearoff 0
.menubar.help.menu add command -label "About..." -underline 0 \
    -command help_about

bind . <Control-o> file_open
bind . <Control-O> file_open

bind . <Control-s> file_save
bind . <Control-S> file_save

bind . <Control-q> file_quit
bind . <Control-Q> file_quit

bind . <Control-t> options_gl_mode
bind . <Control-T> options_gl_mode

pack .menubar -side top -fill x
pack .menubar.file -side left
pack .menubar.view -side left
pack .menubar.options -side left
pack .menubar.help -side left
tk_menuBar .menubar .menubar.file .menubar.help
focus .menubar

proc file_open {} {
    set file [fileselect]
    if {$file != {}} {
        app_set_model $file
    }
}

proc file_save {} {
    puts "file_save"
}

proc file_quit {} {
    exit
}

proc options_gl_mode {} {
    global usegl

    if {[string compare $usegl USEGL_OFF] == 0} {
        set usegl USEGL_ON
    } else {
        set usegl USEGL_OFF
    }
}

proc options_bgcolor {} {
    select_color
}

proc help_about {} {
    set about_text [join [list \
        "Project 4" \
        "COS 426" \
        "CS Department" \
        "Princeton Univerisity"] \n]
    tk_dialog .about "Render" $about_text {} {} OK
}
