/* $Id: my.h,v 1.1 1997/11/05 21:38:11 wtcorrea Exp wtcorrea $ */

#ifndef MY_INCLUDED
#define MY_INCLUDED

void my_traversal_start(void);

void my_traversal_end(void);

void my_separator_start(void);

void my_separator_end(void);

void my_camera(
     float *position,		/* x,y,z */
     float *orientation,	/* x,y,z,theta */
     float near_distance,
     float far_distance,
     float height_angle);

void my_point_light(
     float intensity,
     float *color,		/* r,g,b */
     float *location);		/* x,y,z */

void my_material(
     float *ambient_color,	/* r,g,b */
     float *diffuse_color,	/* r,g,b */
     float *specular_color,	/* r,g,b */
     float *emissive_color,	/* r,g,b */
     float shininess);

void my_scale(float x, float y, float z);

void my_translation(float x, float y, float z);

void my_rotation(float x, float y, float z, float theta);

void my_label(char *label);

void my_triangle(
     float *v0,			/* x,y,z */
     float *v1,
     float *v2,
     float *n0,			/* normal for v0 */
     float *n1,
     float *n2);

void my_cube(float width, float height, float depth);

void my_sphere(float radius);

void my_cone(float bottom_radius, float height);

void my_cylinder(float radius, float height);

#endif
